#include "types.h"
#include "param.h"
#include "riscv.h"
#include "spinlock.h"
#include "timer.h"
#include "proc.h"

struct spinlock tickslock;
uint ticks;

// ask each hart to generate timer interrupts.
void
timerinit(void)
{
  // enable supervisor-mode timer interrupts.
  w_mie(r_mie() | MIE_STIE);
  
  // enable the sstc extension (i.e. stimecmp).
  w_menvcfg(r_menvcfg() | (1L << 63)); 
  
  // allow supervisor to use stimecmp and time.
  w_mcounteren(r_mcounteren() | 2);
  
  // ask for the very first timer interrupt.
  w_stimecmp(r_time() + H_TIMER_FREQ / TIMER_DIV);
}
