#include "userlock.h"
#include "kernel/types.h" // For int, uint definitions
#include "kernel/riscv.h" // For atomic operations

// Initialize the lock
void userlock_init(userlock_t *lock) {
    lock->locked = 0;
}

// Acquire the lock
void userlock_acquire(userlock_t *lock) {
    while (__sync_lock_test_and_set(&(lock->locked), 1)) {
        // Busy-wait until the lock is released
    }
}

// Release the lock
void userlock_release(userlock_t *lock) {
    __sync_lock_release(&(lock->locked));
}
