#ifndef USERLOCK_H
#define USERLOCK_H

// User-level spinlock structure
typedef struct {
    int locked; // Lock state: 0 = unlocked, 1 = locked
} userlock_t;

// Initialize the lock
void userlock_init(userlock_t *lock);

// Acquire the lock (blocking)
void userlock_acquire(userlock_t *lock);

// Release the lock
void userlock_release(userlock_t *lock);

#endif // USERLOCK_H
